%global __provides_exclude_from %{?__provides_exclude_from:%__provides_exclude_from|}^%{_libexecdir}
%global __requires_exclude ^perl\\(ENVDumper\\)|^perl\\(TempDir\\)|^perl\\(Carp::Foo\\)

Summary:        Create and use a local lib/ for perl modules with PERL5LIB
Name:           perl-local-lib
Version:        2.000029
Release:        5%{?dist}
License:        GPL+ or Artistic
Url:            https://metacpan.org/release/local-lib
Source0:        https://cpan.metacpan.org/authors/id/H/HA/HAARG/local-lib-%{version}.tar.gz
Source1:        perl-homedir.sh

BuildRequires:  coreutils make
BuildRequires:  perl-generators perl-interpreter
BuildRequires:  perl(CPAN) perl(CPAN::HandleConfig)
BuildRequires:  perl(ExtUtils::MakeMaker) >= 7.00
BuildRequires:  perl(File::HomeDir) perl(File::Spec) perl(File::Basename) perl(File::Glob) perl(File::Spec) 
BuildRequires:  perl(File::Basename) perl(File::Glob) perl(File::Path) perl(File::Spec::Functions) perl(File::Temp)
BuildRequires:  perl(strict) perl(warnings) perl(Config) perl(base) perl(Cwd) perl(Carp) perl(Carp::Heavy)
BuildRequires:  perl(Data::Dumper) perl(Exporter) perl(IPC::Open3)  perl(lib) perl(Test::More)
Requires:       perl(Carp) perl(Carp::Heavy) perl(File::Basename) perl(File::Glob) perl(File::Spec)

BuildArch:      noarch

%description
This module provides a quick, convenient way of bootstrapping a user-local Perl module
library located within the user's home directory. When an upstream maintainer hasn't
applied a patch to a module of theirs that you need for your application, local::lib
allows you to create your own directory of Perl packages downloaded from CPAN. The
existing system Perl installation is not affected; you simply invoke Perl with special
options so that Perl uses the packages in your own local package directory rather than
the system packages. local::lib arranges things so that your locally installed version
of the Perl packages takes precedence over the system installation.

%package -n perl-homedir
Summary:    Automatically setup user $HOME
License:    GPL+ or Artistic
Requires:   %{name} = %{version}-%{release}
Requires:   sed

%description -n perl-homedir
perl-homedir automatically create a ~/perl5 directory in user's $HOME when user
login. If you want your users to be able to install and use their own Perl modules,
install this package.

%prep
%autosetup -n local-lib-%{version}
for F in t/*.t; do
    perl -i -MConfig -ple 'print $Config{startperl} if $. == 1 && !s{\A#!.*perl\b}{$Config{startperl}}' "$F"
    chmod +x "$F"
done

%build
perl Makefile.PL INSTALLDIRS=vendor NO_PACKLIST=1 NO_PERLLOCAL=1
%make_build

%install
%make_install
%{_fixperms} %{buildroot}/*
mkdir -p %{buildroot}%{_sysconfdir}/profile.d
install -pm0644 %{SOURCE1} %{buildroot}%{_sysconfdir}/profile.d/

%check
export HARNESS_OPTIONS=j%{_smp_build_ncpus}
make test

%files
%doc Changes
%{perl_vendorlib}/*
%{_mandir}/man3/*

%files -n perl-homedir
%{_sysconfdir}/profile.d/*

%changelog
* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.000029-5
- Rebuilt for OpenCloudOS Stream 23.09

* Wed Aug 16 2023 Xiaojie Chen <jackxjchen@tencent.com> - 2.000029-4
- Remove perl(:MODULE_COMPAT) which will be generated by perl-generators >= 1.15

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.000029-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.000029-2
- Rebuilt for OpenCloudOS Stream 23

* Thu Aug 11 2022 ZoeDong <zoedong@tencent.com> - 2.000029-1
- Initial build

